LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

ENTITY GIOBUSOUTPUT IS

	PORT
	(
		TS1			: IN	STD_LOGIC;
		TS2			: IN	STD_LOGIC;
		B_RESET		: IN	STD_LOGIC;
		B_CLK		: IN	STD_LOGIC;
		B_IORN		: IN	STD_LOGIC;
		GIO_ADD		: IN	STD_LOGIC;
		OUT_DATA	: OUT 	STD_LOGIC_VECTOR(7 downto 0)
	);
END GIOBUSOUTPUT;

ARCHITECTURE RTL OF GIOBUSOUTPUT IS

BEGIN
process(GIO_ADD,B_RESET)
	begin
		if (GIO_ADD='1') then
			OUT_DATA <= TS1 & TS2 & "000000";
			-- operater & means Bind operation.
		else
			OUT_DATA <= "ZZZZZZZZ";
		end if;
end process;
END RTL;




